=begin
#Payment Gateway API Specification.

#The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.

The version of the OpenAPI document: 21.3.0.20210608.001

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.1

=end

require 'date'

module OpenapiClient
  # ACH TeleCheck response.
  class AchResponse
    # Response code for TeleCheck authentication decision in the sale response message.
    attr_accessor :response_code

    # Code provided if check is approved.
    attr_accessor :approval_code

    # Reference number.
    attr_accessor :reference_number

    # Preferred flag.
    attr_accessor :preferred_flag

    # Indicates the result of the requested authorization and is returned in the sale response.
    attr_accessor :transaction_status

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'response_code' => :'responseCode',
        :'approval_code' => :'approvalCode',
        :'reference_number' => :'referenceNumber',
        :'preferred_flag' => :'preferredFlag',
        :'transaction_status' => :'transactionStatus'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'response_code' => :'String',
        :'approval_code' => :'String',
        :'reference_number' => :'String',
        :'preferred_flag' => :'String',
        :'transaction_status' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `OpenapiClient::AchResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `OpenapiClient::AchResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'response_code')
        self.response_code = attributes[:'response_code']
      end

      if attributes.key?(:'approval_code')
        self.approval_code = attributes[:'approval_code']
      end

      if attributes.key?(:'reference_number')
        self.reference_number = attributes[:'reference_number']
      end

      if attributes.key?(:'preferred_flag')
        self.preferred_flag = attributes[:'preferred_flag']
      end

      if attributes.key?(:'transaction_status')
        self.transaction_status = attributes[:'transaction_status']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@response_code.nil? && @response_code.to_s.length > 2
        invalid_properties.push('invalid value for "response_code", the character length must be smaller than or equal to 2.')
      end

      if !@approval_code.nil? && @approval_code.to_s.length > 4
        invalid_properties.push('invalid value for "approval_code", the character length must be smaller than or equal to 4.')
      end

      if !@preferred_flag.nil? && @preferred_flag.to_s.length > 1
        invalid_properties.push('invalid value for "preferred_flag", the character length must be smaller than or equal to 1.')
      end

      if !@transaction_status.nil? && @transaction_status.to_s.length > 1
        invalid_properties.push('invalid value for "transaction_status", the character length must be smaller than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@response_code.nil? && @response_code.to_s.length > 2
      return false if !@approval_code.nil? && @approval_code.to_s.length > 4
      return false if !@preferred_flag.nil? && @preferred_flag.to_s.length > 1
      return false if !@transaction_status.nil? && @transaction_status.to_s.length > 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] response_code Value to be assigned
    def response_code=(response_code)
      if !response_code.nil? && response_code.to_s.length > 2
        fail ArgumentError, 'invalid value for "response_code", the character length must be smaller than or equal to 2.'
      end

      @response_code = response_code
    end

    # Custom attribute writer method with validation
    # @param [Object] approval_code Value to be assigned
    def approval_code=(approval_code)
      if !approval_code.nil? && approval_code.to_s.length > 4
        fail ArgumentError, 'invalid value for "approval_code", the character length must be smaller than or equal to 4.'
      end

      @approval_code = approval_code
    end

    # Custom attribute writer method with validation
    # @param [Object] preferred_flag Value to be assigned
    def preferred_flag=(preferred_flag)
      # if !preferred_flag.nil? && preferred_flag.to_s.length > 1
      #   fail ArgumentError, 'invalid value for "preferred_flag", the character length must be smaller than or equal to 1.'
      # end

      @preferred_flag = preferred_flag
    end

    # Custom attribute writer method with validation
    # @param [Object] transaction_status Value to be assigned
    def transaction_status=(transaction_status)
      # if !transaction_status.nil? && transaction_status.to_s.length > 1
      #   fail ArgumentError, 'invalid value for "transaction_status", the character length must be smaller than or equal to 1.'
      # end

      @transaction_status = transaction_status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          response_code == o.response_code &&
          approval_code == o.approval_code &&
          reference_number == o.reference_number &&
          preferred_flag == o.preferred_flag &&
          transaction_status == o.transaction_status
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [response_code, approval_code, reference_number, preferred_flag, transaction_status].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes, attribute_map = self.class.attribute_map, openapi_types = self.class.openapi_types)
      return nil unless attributes.is_a?(Hash)
      openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        klass = OpenapiClient.const_get(type)
        if klass.respond_to?(:openapi_discriminator_name)
          klass = OpenapiClient.const_get(value[klass.attribute_map[klass.openapi_discriminator_name]])
        end
 
        klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash(attribute_map = self.class.attribute_map, openapi_nullable = Set.new([]))
      hash = {}
      attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
