=begin
#Payment Gateway API Specification.

#The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.

The version of the OpenAPI document: 21.3.0.20210608.001

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.1

=end

require 'date'

module OpenapiClient
  # Additional information about the route.
  class AirlineTravelRoute
    # Date of departure.
    attr_accessor :departure_date

    # The IATA code for the departure airport.
    attr_accessor :origin

    # The IATA code for the destination. airport.
    attr_accessor :destination

    # The IATA code for the carrier.
    attr_accessor :carrier_code

    # The airline code for the service class of the ticket.
    attr_accessor :service_class

    # Indicates whether the route is direct.
    attr_accessor :stopover_type

    # The airline fare basis code.
    attr_accessor :fare_basis_code

    # Fee charged by a country when a person leaves the country.
    attr_accessor :departure_tax

    # The airline flight number associated with the ticket.
    attr_accessor :flight_number

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'departure_date' => :'departureDate',
        :'origin' => :'origin',
        :'destination' => :'destination',
        :'carrier_code' => :'carrierCode',
        :'service_class' => :'serviceClass',
        :'stopover_type' => :'stopoverType',
        :'fare_basis_code' => :'fareBasisCode',
        :'departure_tax' => :'departureTax',
        :'flight_number' => :'flightNumber'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'departure_date' => :'Date',
        :'origin' => :'String',
        :'destination' => :'String',
        :'carrier_code' => :'String',
        :'service_class' => :'String',
        :'stopover_type' => :'String',
        :'fare_basis_code' => :'String',
        :'departure_tax' => :'Float',
        :'flight_number' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `OpenapiClient::AirlineTravelRoute` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `OpenapiClient::AirlineTravelRoute`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'departure_date')
        self.departure_date = attributes[:'departure_date']
      end

      if attributes.key?(:'origin')
        self.origin = attributes[:'origin']
      end

      if attributes.key?(:'destination')
        self.destination = attributes[:'destination']
      end

      if attributes.key?(:'carrier_code')
        self.carrier_code = attributes[:'carrier_code']
      end

      if attributes.key?(:'service_class')
        self.service_class = attributes[:'service_class']
      end

      if attributes.key?(:'stopover_type')
        self.stopover_type = attributes[:'stopover_type']
      end

      if attributes.key?(:'fare_basis_code')
        self.fare_basis_code = attributes[:'fare_basis_code']
      end

      if attributes.key?(:'departure_tax')
        self.departure_tax = attributes[:'departure_tax']
      end

      if attributes.key?(:'flight_number')
        self.flight_number = attributes[:'flight_number']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@origin.nil? && @origin.to_s.length > 3
        invalid_properties.push('invalid value for "origin", the character length must be smaller than or equal to 3.')
      end

      if !@destination.nil? && @destination.to_s.length > 3
        invalid_properties.push('invalid value for "destination", the character length must be smaller than or equal to 3.')
      end

      if !@carrier_code.nil? && @carrier_code.to_s.length > 2
        invalid_properties.push('invalid value for "carrier_code", the character length must be smaller than or equal to 2.')
      end

      if !@service_class.nil? && @service_class.to_s.length > 1
        invalid_properties.push('invalid value for "service_class", the character length must be smaller than or equal to 1.')
      end

      if !@fare_basis_code.nil? && @fare_basis_code.to_s.length > 2
        invalid_properties.push('invalid value for "fare_basis_code", the character length must be smaller than or equal to 2.')
      end

      if !@departure_tax.nil? && @departure_tax > 999999999999
        invalid_properties.push('invalid value for "departure_tax", must be smaller than or equal to 999999999999.')
      end

      if !@flight_number.nil? && @flight_number.to_s.length > 10
        invalid_properties.push('invalid value for "flight_number", the character length must be smaller than or equal to 10.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@origin.nil? && @origin.to_s.length > 3
      return false if !@destination.nil? && @destination.to_s.length > 3
      return false if !@carrier_code.nil? && @carrier_code.to_s.length > 2
      return false if !@service_class.nil? && @service_class.to_s.length > 1
      stopover_type_validator = EnumAttributeValidator.new('String', ["DIRECT", "STOPOVER"])
      return false unless stopover_type_validator.valid?(@stopover_type)
      return false if !@fare_basis_code.nil? && @fare_basis_code.to_s.length > 2
      return false if !@departure_tax.nil? && @departure_tax > 999999999999
      return false if !@flight_number.nil? && @flight_number.to_s.length > 10
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] origin Value to be assigned
    def origin=(origin)
      if !origin.nil? && origin.to_s.length > 3
        fail ArgumentError, 'invalid value for "origin", the character length must be smaller than or equal to 3.'
      end

      @origin = origin
    end

    # Custom attribute writer method with validation
    # @param [Object] destination Value to be assigned
    def destination=(destination)
      if !destination.nil? && destination.to_s.length > 3
        fail ArgumentError, 'invalid value for "destination", the character length must be smaller than or equal to 3.'
      end

      @destination = destination
    end

    # Custom attribute writer method with validation
    # @param [Object] carrier_code Value to be assigned
    def carrier_code=(carrier_code)
      if !carrier_code.nil? && carrier_code.to_s.length > 2
        fail ArgumentError, 'invalid value for "carrier_code", the character length must be smaller than or equal to 2.'
      end

      @carrier_code = carrier_code
    end

    # Custom attribute writer method with validation
    # @param [Object] service_class Value to be assigned
    def service_class=(service_class)
      if !service_class.nil? && service_class.to_s.length > 1
        fail ArgumentError, 'invalid value for "service_class", the character length must be smaller than or equal to 1.'
      end

      @service_class = service_class
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] stopover_type Object to be assigned
    def stopover_type=(stopover_type)
      validator = EnumAttributeValidator.new('String', ["DIRECT", "STOPOVER"])
      unless validator.valid?(stopover_type)
        fail ArgumentError, "invalid value for \"stopover_type\", must be one of #{validator.allowable_values}."
      end
      @stopover_type = stopover_type
    end

    # Custom attribute writer method with validation
    # @param [Object] fare_basis_code Value to be assigned
    def fare_basis_code=(fare_basis_code)
      if !fare_basis_code.nil? && fare_basis_code.to_s.length > 2
        fail ArgumentError, 'invalid value for "fare_basis_code", the character length must be smaller than or equal to 2.'
      end

      @fare_basis_code = fare_basis_code
    end

    # Custom attribute writer method with validation
    # @param [Object] departure_tax Value to be assigned
    def departure_tax=(departure_tax)
      if !departure_tax.nil? && departure_tax > 999999999999
        fail ArgumentError, 'invalid value for "departure_tax", must be smaller than or equal to 999999999999.'
      end

      @departure_tax = departure_tax
    end

    # Custom attribute writer method with validation
    # @param [Object] flight_number Value to be assigned
    def flight_number=(flight_number)
      if !flight_number.nil? && flight_number.to_s.length > 10
        fail ArgumentError, 'invalid value for "flight_number", the character length must be smaller than or equal to 10.'
      end

      @flight_number = flight_number
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          departure_date == o.departure_date &&
          origin == o.origin &&
          destination == o.destination &&
          carrier_code == o.carrier_code &&
          service_class == o.service_class &&
          stopover_type == o.stopover_type &&
          fare_basis_code == o.fare_basis_code &&
          departure_tax == o.departure_tax &&
          flight_number == o.flight_number
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [departure_date, origin, destination, carrier_code, service_class, stopover_type, fare_basis_code, departure_tax, flight_number].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes, attribute_map = self.class.attribute_map, openapi_types = self.class.openapi_types)
      return nil unless attributes.is_a?(Hash)
      openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        klass = OpenapiClient.const_get(type)
        if klass.respond_to?(:openapi_discriminator_name)
          klass = OpenapiClient.const_get(value[klass.attribute_map[klass.openapi_discriminator_name]])
        end
 
        klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash(attribute_map = self.class.attribute_map, openapi_nullable = Set.new([]))
      hash = {}
      attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
