=begin
#Payment Gateway API Specification.

#The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.

The version of the OpenAPI document: 21.3.0.20210608.001

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.1

=end

require 'date'

module OpenapiClient
  # Use this model to provide order related details.
  class Order
    # Note - Client Order ID if supplied by client. If not supplied by client, IPG will generate. The first 12 alphanumeric digits are passed down to Fiserv Enterprise reporting tool, Clientline and Data File Manager (DFM).
    attr_accessor :order_id

    attr_accessor :billing

    attr_accessor :shipping

    attr_accessor :industry_specific_extensions

    attr_accessor :purchase_card

    attr_accessor :installment_options

    attr_accessor :revolving_options

    attr_accessor :stand_in_details

    attr_accessor :soft_descriptor

    attr_accessor :additional_details

    attr_accessor :bancontact_qr

    attr_accessor :client_locale

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'order_id' => :'orderId',
        :'billing' => :'billing',
        :'shipping' => :'shipping',
        :'industry_specific_extensions' => :'industrySpecificExtensions',
        :'purchase_card' => :'purchaseCard',
        :'installment_options' => :'installmentOptions',
        :'revolving_options' => :'revolvingOptions',
        :'stand_in_details' => :'standInDetails',
        :'soft_descriptor' => :'softDescriptor',
        :'additional_details' => :'additionalDetails',
        :'bancontact_qr' => :'bancontactQR',
        :'client_locale' => :'clientLocale'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'order_id' => :'String',
        :'billing' => :'Billing',
        :'shipping' => :'Shipping',
        :'industry_specific_extensions' => :'IndustrySpecificExtensions',
        :'purchase_card' => :'PurchaseCards',
        :'installment_options' => :'InstallmentOptions',
        :'revolving_options' => :'RevolvingOptions',
        :'stand_in_details' => :'StandInDetails',
        :'soft_descriptor' => :'SoftDescriptor',
        :'additional_details' => :'AdditionalDetails',
        :'bancontact_qr' => :'BancontactQR',
        :'client_locale' => :'ClientLocale'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `OpenapiClient::Order` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `OpenapiClient::Order`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'order_id')
        self.order_id = attributes[:'order_id']
      end

      if attributes.key?(:'billing')
        self.billing = attributes[:'billing']
      end

      if attributes.key?(:'shipping')
        self.shipping = attributes[:'shipping']
      end

      if attributes.key?(:'industry_specific_extensions')
        self.industry_specific_extensions = attributes[:'industry_specific_extensions']
      end

      if attributes.key?(:'purchase_card')
        self.purchase_card = attributes[:'purchase_card']
      end

      if attributes.key?(:'installment_options')
        self.installment_options = attributes[:'installment_options']
      end

      if attributes.key?(:'revolving_options')
        self.revolving_options = attributes[:'revolving_options']
      end

      if attributes.key?(:'stand_in_details')
        self.stand_in_details = attributes[:'stand_in_details']
      end

      if attributes.key?(:'soft_descriptor')
        self.soft_descriptor = attributes[:'soft_descriptor']
      end

      if attributes.key?(:'additional_details')
        self.additional_details = attributes[:'additional_details']
      end

      if attributes.key?(:'bancontact_qr')
        self.bancontact_qr = attributes[:'bancontact_qr']
      end

      if attributes.key?(:'client_locale')
        self.client_locale = attributes[:'client_locale']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@order_id.nil? && @order_id.to_s.length > 100
        invalid_properties.push('invalid value for "order_id", the character length must be smaller than or equal to 100.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@order_id.nil? && @order_id.to_s.length > 100
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] order_id Value to be assigned
    def order_id=(order_id)
      if !order_id.nil? && order_id.to_s.length > 100
        fail ArgumentError, 'invalid value for "order_id", the character length must be smaller than or equal to 100.'
      end

      @order_id = order_id
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          order_id == o.order_id &&
          billing == o.billing &&
          shipping == o.shipping &&
          industry_specific_extensions == o.industry_specific_extensions &&
          purchase_card == o.purchase_card &&
          installment_options == o.installment_options &&
          revolving_options == o.revolving_options &&
          stand_in_details == o.stand_in_details &&
          soft_descriptor == o.soft_descriptor &&
          additional_details == o.additional_details &&
          bancontact_qr == o.bancontact_qr &&
          client_locale == o.client_locale
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [order_id, billing, shipping, industry_specific_extensions, purchase_card, installment_options, revolving_options, stand_in_details, soft_descriptor, additional_details, bancontact_qr, client_locale].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes, attribute_map = self.class.attribute_map, openapi_types = self.class.openapi_types)
      return nil unless attributes.is_a?(Hash)
      openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        klass = OpenapiClient.const_get(type)
        if klass.respond_to?(:openapi_discriminator_name)
          klass = OpenapiClient.const_get(value[klass.attribute_map[klass.openapi_discriminator_name]])
        end
 
        klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash(attribute_map = self.class.attribute_map, openapi_nullable = Set.new([]))
      hash = {}
      attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
